# IP toets: De Britania

Voor deze toets ga je “The Britania Passenger app!” maken. Dat is een applicatie om de passagiers van het schip Britania te registreren. Voor elke passagier wordt de naam, geslacht, leeftijd, gewicht en de reis-klasse vastgelegd.

Als de gebruiker de applicatie opstart wordt er een menu getoond. Dit menu geeft de volgende opties en functionaliteit:

![Applicatie menu](resources/app_screen1.png)

Let op: Het aantal aantal passagiers zal in het begin 0 (nul) zijn. Nadat je menuoptie 1 hebt gekozen en je succesvol gegevens van de passagiers hebt ingelezen zou het aantal overeen moeten komen met het aantal passagiers dat in de csv file staat.

**Optie 1: Read from passengers.csv**

De applicatie zal het bestand passengers.csv inlezen en alle passagiers toevoegen die genoemd zijn in het bestand. Zorg bij het lezen dat de eerste regel van het bestand overgeslagen wordt.

**Optie 2: Add a passenger**

De applicatie geeft een overzicht van alle passagiers. Voor iedere passagier moeten de volgende gegevens worden getoond:
- naam (name)
- geslacht (sex)
- reis-klasse (class)
- leeftijd (age)
- gewicht (weight)

![Applicatie menu](resources/app_screen2.png)

**Optie 3: Add a passenger**

De applicatie vraagt de gebruiker voor de naam, het geslacht, de klasse, de leeftijd en het gewicht van de passagier. De applicatie controleert dat de invoer van geslacht, klasse, leeftijd en gewicht binnen de geldige waarden ligt. Dit zijn de geldige waarden:

| Item   | Regels                              |
|--------|-------------------------------------|
| Name   | Mag niet leeg zijn                  |
| Sex    | M, F, N  (Male, Female, Non-binary) |
| Class  | 1,2,3                               |
| Age    | Getal tussen 0 en 110               |
| Weight | Getal tussen 40.0 en 120.0          |

![Add a passenger](resources/app_screen3.png)

**Optie 4: Show statistics**

Toon een aantal statistieken van de passagierslijst. De statistieken moeten er als volgt uitzien:

![Add a passenger](resources/app_screen4.png)

Bovenaan wordt eerst de oudste passagier getoond (dus met de hoogste leeftijd). Als er meerdere passagiers zijn met dezelfde hoogste leeftijd maakt het niet uit welke passagier je hiervan toont.

Daarna wordt het totale gewicht van alle passagiers getoond, hier wordt 1 decimaal voor gebruikt.

Daaronder wordt per klasse het percentage getoond van het aantal passagiers in die klasse in een balkje. Dit betekent dat als er alleen eersteklaspassagiers zouden zijn, de hele bovenste balk gevuld is met geel en de andere geen gele balk hebben.
Hieronder staat dezelfde afbeelding, maar dan met uitleg erin om je met de layout te helpen.

![Add a passenger](resources/app_screen5.png)

**Een aantal tips om te beginnen**
- Het belangrijkste: Lees de opdracht goed!
- Begin met het structureren van je programma. Bijvoorbeeld door code commentaar te typen, zoals je geleerd bij dit vak.
- Begin klein, met een klein probleem dat je kunt oplossen.
- Start je programma vaak om te kijken of het werkt! Niet alleen aan het einde.
- Onthoud en pas alles wat je hebt geleerd over goede code toe. Denk bijvoorbeeld aan goede variabelen namen en gebruik methodes op plekken waar je denkt dat ze nodig zijn.
- De csv file kan worden geopend door gewoon ```new CsvReader(“passengers.csv”);```. Er is geen additioneel pad of verwijzing naar een map o.i.d. nodig.
- Mocht je vastzitten. Probeer een workaround te bedenken. Bijvoorbeeld: Als je niet weet hoe je het csv bestand moeten inlezen maak dan handmatig wat passagiers aan.
- Veel succes